---
title: 数据下拉组件用法
order: 2
---

```jsx
import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import { YwJsonForm } from '@ywfe/yw-design';
import 'antd/dist/antd.css';
const items = [
  {
    title: '普通下拉框',
    name: 'select1',
    component: 'Select',
    required:true,
    defaultValue:1,
    enum: [ // 不推荐使用
      { label: "AAA", value: 1 },
      { label: "BBB", value: 2 },
    ],
  },
  {
    title: '自定义数据节点',
    name: 'select2',
    component: 'Select',
    componentProps: {
      dataSource: [
        { name: 'AAA', code: 1 },
        { name: 'BBB', code: 2 },
      ],
      fieldNames: {label: 'name', value: 'code'}, // 默认 {label: 'label', value: 'value'}
    },
  },
  {
    title: '字典数据',
    name: 'select3',
    component: 'Select',
    componentProps: {
        dict:[
            {dictName:'待审核',dictValue:1},
            {dictName:'已审核',dictValue:2}
        ]
    },
  },
  {
    title: '异步数据',
    name: 'select4',
    component: 'Select',
    componentProps:{
      placeholder:'请输入',
      fieldNames: {label: 'name', value: 'code'},
      getDataSource: async (field) => {
        return new Promise((resolve) => {
          setTimeout(() => {
            resolve([
              {
                name: 'AAA',
                code: 'aaa',
              },
              {
                name: 'BBB',
                code: 'ccc',
              },
            ]);
            field.setValue('aaa')
          }, 1500);
        });
      },
    },
  },
  {
    title: '远程搜索',
    name: 'asnySearchSelect',
    component: 'SearchSelect',
    type: 'array',
    componentProps:{
      placeholder:'请输入',
      mode:'multiple',
      showArrow:true,
      fieldNames: {label: 'name', value: 'code'},
      getDataSource: async (keyword) => {
        return new Promise((resolve) => {
          setTimeout(() => {
            resolve([
              {
                label: 'AAA',
                value: 'aaa',
              },
              {
                label: 'BBB',
                value: 'ccc',
              },
            ]);
          }, 1500);
        });
      },
    }
  },
];
const App =() => {
    return (
      <div>
        <YwJsonForm items={items} />
      </div>
    );
}

ReactDOM.render(<App />, mountNode);
```
