import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
var _excluded = ["title", "size", "btnText", "btnType", "items", "disabled", "editable", "initialValues", "layoutProps", "btnDisabled", "children", "linkages", "onCancel", "onConfirm", "onOpen", "onFormInit"];
import React, { useState, useMemo, useEffect } from 'react';
import styles from "./index.module.less";
import { Button, Modal, Spin } from 'antd';
import { YwJsonForm } from "../YwJsonForm";
import YwButton from "../YwButton";
var widthMap = {
  s: 680,
  m: 920,
  l: 1200,
  full: '100vw'
};

var YwFormDialog = function YwFormDialog(_ref) {
  var title = _ref.title,
      size = _ref.size,
      btnText = _ref.btnText,
      btnType = _ref.btnType,
      items = _ref.items,
      disabled = _ref.disabled,
      editable = _ref.editable,
      initialValues = _ref.initialValues,
      layoutProps = _ref.layoutProps,
      btnDisabled = _ref.btnDisabled,
      children = _ref.children,
      linkages = _ref.linkages,
      _onCancel = _ref.onCancel,
      onConfirm = _ref.onConfirm,
      onOpen = _ref.onOpen,
      onFormInit = _ref.onFormInit,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useState = useState(others.visible || false),
      visible = _useState[0],
      setVisible = _useState[1];

  var isControl = useMemo(function () {
    return others.visible !== undefined;
  }, []);

  var _useState2 = useState(null),
      form = _useState2[0],
      setForm = _useState2[1];

  var _useState3 = useState(false),
      spinning = _useState3[0],
      setSpinning = _useState3[1];

  var _useState4 = useState(false),
      confirmLoading = _useState4[0],
      setConfirmLoading = _useState4[1]; // const form = useMemo(() => {
  //   return visible
  //     ? createForm({
  //         disabled,
  //         editable,
  //         initialValues,
  //         effects: (form) => {
  //           onFormInit
  //         },
  //       })
  //     : null;
  // }, [visible]);
  // const showModal = () => {
  //   if (isFunction(onOpen)) {
  //     setSpinning(true);
  //     onOpen()
  //       .then((initialValues) => {
  //         form.setValues(initialValues);
  //       })
  //       .finally(() => {
  //         setSpinning(false);
  //       });
  //   }
  // };


  var handleOk = function handleOk() {
    form.submit().then(function (value) {
      if (isControl) {
        onConfirm(value);
      } else {
        setConfirmLoading(true);
        onConfirm(value).then(function () {
          setVisible(false);
        })["finally"](function () {
          setConfirmLoading(false);
        });
      }
    });
  }; // const handleCancel = () => {
  //   onCancel();
  //   setConfirmLoading(false);
  // };


  useEffect(function () {
    setVisible(others.visible);
  }, [others.visible]); // useEffect(() => {
  //   if (visible) {
  //     showModal();
  //   } else {
  //     handleCancel();
  //   }
  // }, [visible]);

  return /*#__PURE__*/React.createElement(React.Fragment, null, others.visible === undefined && /*#__PURE__*/React.createElement("div", {
    onClick: function onClick() {
      setVisible(true);
    },
    style: {
      display: 'inline-block'
    }
  }, children || /*#__PURE__*/React.createElement(Button, {
    type: btnType,
    disabled: btnDisabled
  }, btnText)), /*#__PURE__*/React.createElement(Modal, _extends({}, others, {
    wrapClassName: styles['yw-form-dialog'],
    title: title,
    width: widthMap[size],
    visible: visible,
    onOk: handleOk,
    destroyOnClose: true,
    maskClosable: false,
    okText: "\u786E\u5B9A" // cancelText={editable ? '取消' : '关闭'}
    ,
    confirmLoading: confirmLoading,
    onCancel: function onCancel() {
      !isControl ? setVisible(false) : _onCancel();
    },
    footer: [/*#__PURE__*/React.createElement(YwButton, {
      key: "back",
      onClick: function onClick() {
        !isControl ? setVisible(false) : _onCancel();
      }
    }, editable ? '取消' : '关闭'), editable ? [/*#__PURE__*/React.createElement(YwButton, {
      key: "submit",
      btnType: "primary",
      loading: confirmLoading,
      onClick: handleOk
    }, "\u786E\u5B9A")] : []]
  }), /*#__PURE__*/React.createElement(Spin, {
    spinning: spinning
  }, /*#__PURE__*/React.createElement(YwJsonForm, {
    items: items,
    editable: editable,
    initialValues: initialValues,
    onCreate: function onCreate(_form) {
      setForm(_form);
      onFormInit(_form);
    },
    disabled: disabled,
    layoutProps: layoutProps,
    buttons: [],
    linkages: linkages
  }))));
};

YwFormDialog.defaultProps = {
  btnType: 'primary',
  size: 's',
  btnDisabled: false,
  editable: true,
  onCancel: function onCancel() {},
  onConfirm: function onConfirm() {},
  onFormInit: function onFormInit(any) {}
};
export default YwFormDialog;